/**  thinning.c  **/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "thinning.h"
#include "pnm.h"
//#include <math.h>

void quita_marcados ( MATRIX * IN )
{
	int row, column;
	unsigned char  *inptr;

	for ( row=1; row < (IN->rows)-3; row++ ) {
		inptr = (unsigned char *) IN->ptr[ row ];
		for ( column = 1; column < (IN->cols)-3 ; column++ ) { 
			if ( *inptr == 1 ) *inptr = (unsigned char) 0xFF;
			inptr++;
		}
	}
}


int thinning( MATRIX * IN, int paso )
{
	int P[9], Porden[10];
	int *ptrP, *paux;
	int row, column, i, j, k;
	int sumaN, sp;
	int cambio = 0;
	unsigned char *outptr, *inptr;
	for ( row=1; row < (IN->rows)-3; row++ ) {
		outptr = (unsigned char *) IN->ptr[ row + 1 ];
		for ( column = 1; column < (IN->cols)-3 ; column++ ) {
			/** Se llena P con una ventana de 3x3 **/
			k=0;
			for ( i = 0 ; i < 3; i++ ) {
				inptr = (unsigned char *) IN->ptr[ i+row ];
				inptr = inptr + column;
				for ( j = 0 ; j < 3; j++ ){
					P[k++] =  *inptr++>1 ? 1 : 0; //1 : 0;
				}
			}
			if( !P[4] ) {
				/** Se copia P en onden en Porden[] **/
				Porden[0] = P[4]; Porden[1] = P[1]; Porden[2] = P[2];
				Porden[3] = P[5]; Porden[4] = P[8]; Porden[5] = P[7];
				Porden[6] = P[6]; Porden[7] = P[3]; Porden[8] = P[0];
				Porden[9] = P[1];
				ptrP = Porden + 1;
				sumaN = 0;
				for (i=0; i<8; i++) if( ! *ptrP++ ) sumaN++;
				if ( sumaN>=2 && sumaN<=6 ) {
					/** No. de transiciones de 0-1 **/
					ptrP = Porden + 1;
					paux = ptrP + 1;
					sp = 0;
					for( i=0; i<8; i++ ) {
					   if( *ptrP>0 && *paux==0 ) sp++;
					   ptrP++;
					   paux++;
					}
					if( sp == 1 ) {
						if ( paso ) {  //Paso 1
						   if( Porden[3] || Porden[5]  ||
							(Porden[1] && Porden[7]) ){
					  		outptr[ column+1 ] = (unsigned char) 1;
							cambio = 1;
						   }
						}
					   	else {  //Paso 2
						   if( Porden[1] || Porden[7]  || 
							(Porden[3] && Porden[5]) ) {
					  		outptr[ column+1 ] = (unsigned char) 1;
							cambio = 1;
						    }
						}
					}
				}
			}

		}
	}
	return( cambio );
}

void esqueleto( MATRIX *IN )
{
	int cambio=1;
	
	while ( cambio ) {
		/** Paso 1 **/
		cambio = thinning( IN, 1 );
		if( !cambio ) break;
		quita_marcados( IN );

 		/** Paso 2 **/
		cambio = thinning( IN, 0 );
		if( !cambio ) break;
		quita_marcados( IN );

	}
	
}


int main ( int argc, char *argv[] )
{
	char namein[64];
	MATRIX *IN;


	if ( argc < 2 ) {
	 	printf("Args: img_name.pbm\n" );
		exit(1);
	}

	strncpy( namein, argv[1], 64 );
	
	/** Read the input image **/
	IN = read_pnm( namein );
	if ( IN == NULL ){
		fprintf( stderr, "Can't read %s file\n", namein );
		return( -1 );
	}

	esqueleto( IN );
	write_pnm( IN, "thinning.pnm" );	
	
	return 0;
}
	

