#ifndef MYUTILS_H
#define MYUTILS_H 1

extern
void rescale( float **imgin, byte **imgout, int rows, int cols );

extern
MATRIX * histogram ( MATRIX * IN );

extern
void print_histogram ( MATRIX * IN );

extern
MATRIX * histogram_equalization( MATRIX * IN, int maxval );

extern
void chamfer( MATRIX *IN );

/** 
	En dht.c
	Discrete Hartley Transform
**/
extern void init_dht( int );
extern void free_dht( void );
extern void dht( float *, float *, int );
extern MATRIX * image_dht( MATRIX * );

/** 
	En dct.c
	Discrete Cosine Transform
**/
extern void init_dct( int n );
extern void free_dct( void );
extern void dct( float *in, float *out, int n, int kind );
/** if kind == 0 Direct evaluation
    if kind == 1 Inverse evaluation  **/
extern MATRIX * image_dct( MATRIX *IN, int kind );

#endif 
